(*;;
#use "c:/ocaml/lib/mlgraph.lib/mlg/mlg";;
*)
;; 
begin_mlPic "graphe" "automate";;

let text s = latexText ~strMl:s ("$" ^ s ^ "$");;

let automate =
  let programme = "\\usebox{\\ProgrammeGraphe}" in
  let g = init_graphe () in
  let s1 = cercle ~graphe:g (text "1")
  and s2 = cercle ~graphe:g (text "2")
  and s4 = cercle ~graphe:g ~dirSommet:Ds (text "4")
  and s3 = cercle ~graphe:g ~dirSommet:Dw (text "3") in
  let a s s' t =
    let _ =
      arete ~graphe:g ~typeSommet1:Ovale ~typeSommet2:Ovale
        ~coeff1:0.3 ~coeff2:0.7
        ~ecart1:10.0 ~ecart2:10.0 
        ~nbrePointes:1 ~etiquette:(text t) s s' in () in
  a s1 s2 "a"; a s2 s1 "a"; a s3 s4 "a"; a s4 s3 "a";
  a s1 s3 "b"; a s3 s1 "b"; a s2 s4 "b"; a s4 s2 "b";
  let _ = fleche In ~graphe:g ~typeSommet:Ovale Dw s1 in
  let _ = fleche Out ~graphe:g ~typeSommet:Ovale Dn s1 in
  let _ = boucle ~graphe:g ~etiquette:(text "c,d") 
                 ~typeSommet:Ovale Dse s4 in
  align_horizontally Align_Center [
    rectangle ~color:white ~marge:0.0 (picture_of_graphe g);
    rectangle ~color:white ~marge:0.0 (latexText ~strMl:"" programme)];;

end_mlPic automate;;
