(*;;
#use "c:/ocaml/lib/mlgraph.lib/mlg/mlg";;
*)

(*mlPicMode := true;;*)

begin_mlPic "pointe" "p";;

let p =
  let len = 200.0
  and rl = 0.75
  and ra1 = 0.2
  and ra2 = 0.05
  and p = origin
  and (x,y) = (1.0,1.0) in
  let m = pAdd p (circlePoint (-. len) (180.0 *. atan2 y x /. pi))
  and l1 = rl *. 0.5 *. len 
  and l2 = ra2 *. len in
  let q = pProduitVectoriel m p 0.0 l1
  and r = pProduitVectoriel m p 0.0 (-. l1) in
  let pq = pProduitVectoriel p q 0.5 l2
  and qr = pProduitVectoriel q r 0.5 (ra1 *. len)
  and rp = pProduitVectoriel r p 0.5 l2 in
  let null a = center_picture (seg [origin]) a in
  let dLongueur ?dirEtiquette a v d tml t =
    let b = pAdd a v in
    let c = 
      let l = -.((d.xc-.b.xc)*.v.xc+.(d.yc-.b.yc)*.v.yc)/.
                 (v.xc*.v.xc+.v.yc*.v.yc) in
      pAdd d (pMult v l) in
    let segment a b = seg ~dashpattern:[1;2] [a;b] in
    group_pictures [
      segment a b;
      segment c d;
      arete
        ?dirEtiquette
        ~nbrePointes:2
        ~etiquette:(latexText ~strMl:tml t)
        (null b) (null c)] in
  let v = pSub q r in
  group_pictures [
    translate_picture (5.0,100.0) (
      arete ~etiquette:(latexText ~strMl:"v" "$v$")
            ~nbrePointes:1 (null m) (null (pAdd m (pMult (pSub p m) 0.4))));
    curve p pq pq q;
    curve p rp rp r;
    curve q qr qr r;
    seg ~dashpattern:[2;2] [r;qr;q;pq;p];
    dLongueur q (pMult v 0.3) qr "ra1 l" "$a_1\\times\\ell$";
    dLongueur ~dirEtiquette:D q (pMult v (-.1.3)) p "l" "$\\ell$";
    dLongueur ~dirEtiquette:G r (pMult (pSub m p) 0.2) q "rl l" "$r\\times\\ell$";
    dLongueur q (pMult (pSub p q) 1.2) pq "ra2 l" "$a_2\\times\\ell$";
    disque p 2.0;
    translate_picture (0.0,10.0) 
      (center_picture (latexText ~strMl:"p" "$p$") p)];;

end_mlPic p;;
